﻿using Eingabeverwaltung.Metamodell;
using System;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 37
    /// </summary>
    public class CheckFixedVarsNotSubstituted : ElementChecker
    {
        public CheckFixedVarsNotSubstituted() : base() { }
        public override bool check(Element e)
        {
            if (e is TransformationStep ts)
            {
                bool result = true;
                string output = "";
                foreach(Substitution sub in ts.substitutions)
                    if (ts.rule.IsFixed(sub.variable))
                        // renamings without changing name are substitutions added at model creating and are no errors
                        if (!(sub.tree is TreeVariable tv && tv.name == sub.variable.name))
                        { result = false; output += sub.variable.name+" "; }
                if (!result) ts.errors.Add(new Error(37, output));
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
